<h5>Search</h5>
<form method="get" action="">
  <input placeholder=" search terms..." id="search" name="q" type="text" aria-label="Search term" />
  <button type="submit" class="button"><i class="icon-search" aria-label="Submit"></i></button>
</form>
<div id="search_results"></div>

<!-- Generate a list of posts so we can index and display them -->
{{ $p := slice }}
{{ range (where .Site.RegularPages "Section" "==" "posts") }}
  {{ $post := dict "link" .RelPermalink "title" .Title "tags" .Params.tags }}
  {{ $p = $p | append $post -}}
{{ end }}
<script>
const posts = JSON.parse(
  {{ $p | jsonify }}
);
const query = new URLSearchParams(window.location.search);
const searchString = query.get('q');

if (searchString) {

// Populate the field with any existing search string
document.querySelector('#search').value = searchString;
const $target = document.querySelector('#search_results');

// Our index uses title as a key of the hashmap
const postsByTitle = posts.reduce((acc, curr) => {
  acc[curr.title] = curr;
  return acc;
}, {});

// The lunr index comes from hugo
index = lunr(function() {
                    this.field("title", { boost: 10 });
                    this.field("tags", { boost: 5 });
                    this.field("link");
                    this.ref("title");

                    posts.forEach(function (page) {
                        this.add(page)
                    }, this)
                });
  const matches = index.search(searchString);

  if (matches.length > 0) {
    $target.innerHTML = matches.map(p => {
      return `<ul>
        <li><a href="${postsByTitle[p.ref].link}">${p.ref}</a></li>
      </ul>`;
    }).join('');
  } else {
    $target.innerHTML = `<div>No search results found</div>`;
  }
}
</script>

<!-- pages -->
<div class="widget-pages">
    <h5>{{ i18n "sidebarPages" }}</h5>
    <ul>
        {{ $currentPage := . }}
        {{ range .Site.Menus.nav }}
        <li>
            <a href="{{ .URL }}">{{ .Name }}</a>
        </li>
        {{ end }}
    </ul>
</div>
<!-- tags -->
<div class="widget-tags">
    <h5>{{ i18n "sidebarTags" }}</h5>
    <div>
        {{ range .Site.Taxonomies.tags }}
        <span>
            <a href="{{ .Page.Permalink }}">{{ .Page.Title }}</a>
        </span>
        {{ end }}
    </div>
</div>
<!-- links -->
<div class="widget-links">
    <h5>{{ i18n "sidebarLinks" }}</h5>
    <ul>
        {{ range .Site.Menus.link }}
        <li>
            <a href="{{ .URL | safeURL }}">{{ .Name }}</a>
        </li>
        {{ end }}
    </ul>
</div>
